/*
* : plugin.h
*
*      
*    ,   .
*       ,   .
*
*/

#ifndef PLUGIN_H
#define PLUGIN_H

/*    ,   
         
   .
     ,  
 */
typedef void(*i8080step_callback_t)(void);

/*       .
    __  (.. -   
      
 */
typedef void(*mpsys_read_callback_t)(WORD addr);
typedef void(*mpsys_write_callback_t)(WORD addr, BYTE *data);

/* ,    */
struct plugin_device {

  /*    */

  char *descr;            /*     */
  void (*reset)(void);    /*    */
  void (*config)(void);   /*     */
  WORD mask;              /*  , 0      */
  WORD port;              /* ,       */

  BYTE (*read)(WORD port);              /*     */
  void (*write)(WORD port, BYTE data);  /*     */


  /*    (   ) */

  //     
  int (*event_add)(DWORD event_time, int type);

  // ,      
  //    
  int (*register_callback)(i8080step_callback_t cb);

  // ,      
  //   
  int (*register_read_callback)(mpsys_read_callback_t cb);

  // ,      
  //    
  int (*register_write_callback)(mpsys_write_callback_t cb);

  BYTE *mem;         /*     */
  DWORD *tstates;    /*      */
  DWORD *mpsys_hz;    /*       */

  HWND hWnd;         /*     */
  HINSTANCE hIsnst;  /*     */

  /*   (   ) */
  struct plugin_device* next;  /*     */
};


#endif
